/* ------------------------------------------------------------------- *
 *                                                                     *
 *   Copyright (C) 2005 Parallels Software Inc. All Rights Reserved.   *
 *                      http://www.parallels.com                       *
 *                                                                     *
 * ------------------------------------------------------------------- *
 *                                                                     *
 * Module: md5.h                                                       *
 *                                                                     *
 * Description:                                                        *
 *  MD5 hash implementation.                                           *
 *                                                                     *
 * Comments:                                                           *
 *  Based on various old code and etc.                                 *
 *                                                                     *
 * Author: ms                                                          *
 * ------------------------------------------------------------------- *
 */

#ifndef __COMMON_MD5_H__
#define __COMMON_MD5_H__

#include "vmmodule.h"

#define rol(x,n) ( ((x) << (n)) | ((x) >> (32-(n))) )
#define FF(a, b, c) (c ^ (a & (b ^ c)))
#define FG(a, b, c) FF (c, a, b)
#define FH(a, b, c) (a ^ b ^ c)
#define FI(a, b, c) (b ^ (a | ~c))

#define BLOCKSIZE 4096 

#define md5SIZE 32
#define md5RSIZE 16

struct md5_ctx {
    u_long A;
    u_long B;
    u_long C;
    u_long D;

    u_long total[2];
    u_long buflen;
    char buffer[128];
} ALIGNED;

int QUICKCALL md5_process_bytes(void *, size_t, struct md5_ctx *);
int QUICKCALL md5_process_block(void *, size_t, struct md5_ctx *);

int QUICKCALL md5_stream(struct file *,void *);
void* QUICKCALL md5_buffer(char *, size_t, void *);

#endif /* __COMMON_MD5_H__ */

