/* ------------------------------------------------------------------- *
 *                                                                     *
 *   Copyright (C) 2005 Parallels Software Inc. All Rights Reserved.   *
 *                      http://www.parallels.com                       *
 *                                                                     *
 * ------------------------------------------------------------------- *
 *                                                                     *
 * Module: timer.h                                                     *
 *                                                                     *
 * Description:                                                        *
 *  Header for internal timer.                                         *
 *                                                                     *
 * Comments:                                                           *
 *                                                                     *
 * Author: ms                                                          *
 * ------------------------------------------------------------------- *
 */

#ifndef __COMMON_TIMER_H__
#define __COMMON_TIMER_H__

struct vmTimer {
    struct list_head list;
    unsigned countdown;
    wait_queue_head_t wq;
};

/* functions for ioctl calls */
int  vmSetTimer(unsigned);
void vmTimerPoll(struct vmTimer*, unsigned);
void vmTimerKill(struct vmTimer*);

/* stop timer on deinit  */
void vmStopTimer(void);

#endif /* __COMMON_TIMER_H__ */
