/* ------------------------------------------------------------------- *
 *                                                                     *
 *   Copyright (C) 2005 Parallels Software Inc. All Rights Reserved.   *
 *                      http://www.parallels.com                       *
 *                                                                     *
 * ------------------------------------------------------------------- *
 *                                                                     *
 * Module: vm_compiler.h                                               *
 *                                                                     *
 * Description:                                                        *
 *  Desfines for compiler.                                             *
 *                                                                     *
 * Comments:                                                           *
 *                                                                     *
 * Author: ms                                                          *
 * ------------------------------------------------------------------- *
 */

#ifndef __COMMON_VM_COMPILER__
#define __COMMON_VM_COMPILER__

/* intercom call */
#ifndef STD_INTERCOM
# define STD_INTERCOM __attribute__((regparm(0), cdecl)) 
#endif

/* stdcall */
#ifndef STDCALL
# define STDCALL __attribute__((regparm(0), stdcall))
#endif

#ifndef QUICKCALL
# define QUICKCALL __attribute__((regparm(3), stdcall))
#endif

/* unused */
#ifndef UNUSED
# define UNUSED __attribute__((unused))
#endif

/* packed attribute */
#ifndef PACKED
# define PACKED __attribute__((packed))
#endif

#ifndef ALIGNED
# define ALIGNED __attribute__((aligned(4)))
#endif

/* packed stuff for consistence with win32 part */
#ifndef STRUCT_NAME
# define STRUCT_NAME(x) PACKED x
#endif

/* weak symbols */
#ifndef WEAK
# define WEAK __attribute__((weak))
#endif

#endif /* __COMMON_VM_COMPILER__ */
