/* ------------------------------------------------------------------- *
 *                                                                     *
 *   Copyright (C) 2005 Parallels Software Inc. All Rights Reserved.   *
 *                      http://www.parallels.com                       *
 *                                                                     *
 * ------------------------------------------------------------------- *
 *                                                                     *
 * Module: vmmodule.h                                                  *
 *                                                                     *
 * Description:                                                        *
 *  Global module defines.                                             *
 *                                                                     *
 * Comments:                                                           *
 *  This file must be included in any module file and before any       *
 *  another header file                                                *
 *                                                                     *
 * Author: ms                                                          *
 * ------------------------------------------------------------------- *
 */

#ifndef __VMMODULE_H__
#define __VMMODULE_H__

/* module */
#define __VM_MODULE__

#include <linux/autoconf.h>
#include <linux/version.h>

/* check for kernel with modules */
#ifndef CONFIG_MODULES
# error "Loadable modules are not supported by this kernel."
# error "Please configure kernel with CONFIG_MODULES enabled"
# error "(Loadable module support -> Enable loadable module support)"
#endif

/* check for version */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 4, 0)
# error "Your kernel version is too old. We does not support kernels lower 2.4.0 version."
#endif

/* check for PAE kernel */
// #ifdef CONFIG_X86_PAE
// # error "Your kernel is compiled with PAE (Physical Address Extension)"
// # error "The current version of the Parallels does not support PAE mode."
// # error "(Processor type and features -> High Memory Support) - must be not more than 4GB"
// #endif

#define EXPORT_SYMTAB

/* check for modversions */
#ifdef CONFIG_MODVERSIONS
# if LINUX_VERSION_CODE < KERNEL_VERSION(2, 5, 60)
#  define MODVERSIONS
#  if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0)
#   include <linux/modversions.h>
#  else
#   include <config/modversions.h>
#  endif
# endif
#endif

/* define kernel */
#ifndef __KERNEL__
# define __KERNEL__
#endif

/* define module */
#ifndef MODULE
# define MODULE
#endif

/* some base headers */
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/compiler.h>

/* really need only in one file */
#ifdef MAIN_MODULE_FILE
/* basic defines */
# define THIS_MODULE (&__this_module)
  MODULE_AUTHOR("Parallels");
  MODULE_DESCRIPTION(MODULE_DESCRIPTION_STRING);
#endif

#include "Config.h"
#include "ConfigVars.h"

#endif /* __VMMODULE_H__ */
