//
// Copyright (C) 2005 Parallels Software Inc. All Rights Reserved.
//
// Author: Sergey Viktorov sergeyv@parallels.ru
//
// $Id: prlnet.h,v 1.2 2006/02/06 13:46:49 mihailsi Exp $
//
#ifndef PRLNET_H_INCLUDED
#define PRLNET_H_INCLUDED

#ifdef _LINUX_
# include <linux/ioctl.h>
#else
# include <sys/ioctl.h>
#endif

typedef struct prlnet_rings_s {
	unsigned recvsize;
	unsigned sendsize;
} prlnet_rings_t;

typedef struct prlnet_bind_s {
	char ifname[16];
	unsigned char mac[6];
} prlnet_bind_t;

#define PRLNET_IOC_MAGIC 0x6E

#define PRLNET_IOCSETRINGS _IOW(PRLNET_IOC_MAGIC, 15, prlnet_rings_t)
#define PRLNET_IOCBIND _IOW(PRLNET_IOC_MAGIC, 16, prlnet_bind_t)
#define PRLNET_IOCKICKSEND _IO(PRLNET_IOC_MAGIC, 17)

#endif // PRLNET_H_INCLUDED
