#ifndef __M__H_PMM
#define __M__H_PMM


#ifdef DYNAMIC_PHYSICAL_MEMORY

#include "Spinlock.h"

#ifdef WIN32
#pragma pack(push, save_pack, 1)
#else
#ifndef STRUCT_NAME
//#define STRUCT_NAME(x) __attribute__((packed)) x
#define STRUCT_NAME(x) x
#endif
#endif


/////////////////////////////////////////////////////////////////////////////
//
// STRUKTURA: PRIMARY_PAGE_ID
//
// NAZNAChENIE:
//		Opisatel' stranitsy. Bloka pamyati
//
/////////////////////////////////////////////////////////////////////////////
typedef struct _PRIMARY_PAGE_ID
{
	//baza v gostevoi pamyati
	UINT uRegionBase;
	//deskriptor hostovoi stranitsy
	UINT PrimaryDesc;
	//razmer regiona
	UINT uRegionSize;
#ifdef CHECK_WITH_CRC
	//CRC dlya proverki
	UINT uCrc;
#endif

}STRUCT_NAME(PRIMARY_PAGE_ID);



/////////////////////////////////////////////////////////////////////////////
//
// STRUKTURA: API_PMM_PAGE
//
// NAZNAChENIE:
//		Struktura dlya API zaprosa dlya poluchaeniya real'nyh fizicheskih stranits
//
/////////////////////////////////////////////////////////////////////////////
typedef struct _API_PMM_PAGE /*: PRIMARY_PAGE_ID*/
{
	//VAZhNO.
	// Iz-za vsyakih privedenii v kode, eta struktura dolzhna byt' v samom nachali
	// ili sdelat' kak nasledovanie (!)
	PRIMARY_PAGE_ID ppID;
	//Indeksy real'nyh fizicheskih stranits
	UINT PhyPageIdxsw[MAX_MEMORY_BLOCK];	//Real Phy Page index
}STRUCT_NAME(API_PMM_PAGE);





typedef struct _GUEST_PHY_MEM_MAN
{
	SPINLOCK	WSSpinLock;
	UINT		uMaxPages;			//Maksimal'no dopustimoe chislo stranits
	UINT		uCurrentPages;		//tekuschee kolichestvo stranits
	UINT		uGuestRamPages;
	INT		iAdjustWorkingSet;	// Izmenenie rabochego nabora. > 0 -uvelichenie
								// <0 - umen'shenie
	UINT		uPagesRequested;

	//Kolichestvo opisannyh etim buferom stranits
	UINT		uBuffPagesCount;
	union{
		//buver peredachi informatsii o allokiruemyh - deallokiruemyh stranitsah.
		API_PMM_PAGE	ApiMem[MAX_PACKED_MEMORY_BLOCKS];
		PRIMARY_PAGE_ID	pPageIds[MAX_ADJUST_WS_PAGES];
	};
}STRUCT_NAME(GUEST_PHY_MEM_MAN);


// Vosstanavlivaem vyravnivanie elementov struktur po umolchaniyu
#ifdef WIN32
#pragma pack(pop, save_pack)
#endif



#endif //DYNAMIC_PHYSICAL_MEMORY


#endif //__M__H_PMM
