/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2005 Parallels Inc. All Rights Reserved.
//		 http://www.parallelssoft.com
//
// Module: Types.h
//
// Description: Types for VM
//
/////////////////////////////////////////////////////////////////////////////
#ifndef __VM_TYPES__
#define __VM_TYPES__

// Standard constants for compilation
#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef FALSE
#define FALSE	0
#endif

#ifndef TRUE
#define TRUE	1
#endif


// Standard datatypes for compilation
// (as in DDK "ntdef.h")
#ifndef VOID
#define VOID	void
typedef char	CHAR;
typedef short	SHORT;
typedef long	LONG;
typedef void	*PVOID;
typedef CHAR	*PCHAR;
typedef SHORT	*PSHORT;
typedef LONG	*PLONG;
#endif

// Definitions as in "ntdef.h"  "windef.h"
#ifndef BASETYPES
#define BASETYPES
typedef unsigned char	UCHAR;
typedef unsigned short	USHORT;
typedef unsigned long	ULONG;
typedef UCHAR		*PUCHAR;
typedef USHORT		*PUSHORT;
typedef ULONG		*PULONG;
typedef char		*PSZ;
#endif

// Analogue of typedefs from "windef.h"
#ifndef _WINDEF_
#define _WINDEF_
typedef int		BOOL;
typedef int		INT;
typedef unsigned int	UINT;
typedef BOOL		*PBOOL;
typedef INT		*PINT;
typedef UINT		*PUINT;
#endif

typedef unsigned long long	__int64;
typedef long long		LONG64;
typedef unsigned long long	ULONG64;
typedef LONG64			*PLONG64;
typedef ULONG64			*PULONG64;
typedef void            	*LPVOID;

#if 0
typedef unsigned char		BYTE;
typedef unsigned short		WORD;
typedef unsigned int		DWORD;
typedef unsigned long long	QWORD;
typedef unsigned short 		WCHAR;
typedef long int 		LONG;
#endif

#endif // ( __VM_TYPES__ )
