#!/bin/sh

tmpdi=r"/tmp/$$"
driver="ni-0.8.11"
interface="ni"
curdir=`pwd`

trap "cd $curdir && rm -rf $tmpdir; exit 0" 1 2 3 6 9 14 15

rm -rf $tmpdir && mkdir -p $tmpdir && cd $tmpdir

gettext "Extracting driver..."; echo
gzcat ${curdir}/ni.tgz | tar xf - &&

gettext "Compiling driver..."; echo
cd $driver && /usr/ccs/bin/make install > /dev/null

gettext "Installing driver..."; echo
./addni.sh > /dev/null

get_answer() {
	input_mask=$1
	answer=''
	while (test -z "`echo $answer | egrep -i $input_mask`"); do
		read answer
	done

	return 0
}

gettext "Will you receive IP addresses from DHCP server (Y/N)"; echo
get_answer "^[YN]$"

if [ -z "`echo $answer | grep -i Y`" ]; then
	nodename=`cat /etc/nodename | tail -1l`
	regexp_ip='^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$'
	gettext "Enter IP address of the virtual machine:"; echo; get_answer $regexp_ip && ip=$answer
	gettext "Enter network address:"; echo; get_answer $regexp_ip && network=$answer
	gettext "Enter network mask:"; echo; get_answer $regexp_ip && mask=$answer
	gettext "Enter default gateway IP address:"; echo; get_answer $regexp_ip && router=$answer

	rm -f /etc/dhcp.ni0
	echo "127.0.0.1\tlocalhost\tloghost" > /etc/inet/hosts
	echo "$ip\t$nodename" >> /etc/inet/hosts
	echo $ip > /etc/hostname.ni0
	cat /etc/netmasks | sed "/$network/d" > /etc/netmasks.new
	echo "$network\t$mask" >> /etc/netmasks.new
	mv /etc/netmasks.new /etc/netmasks
	echo $router > /etc/defaultrouter
	
else
	gettext "Configuring DHCP client..."; echo
	cat /dev/null > /etc/hostname.ni0
	cat /dev/null > /etc/dhcp.ni0
	rm -f /etc/defaultrouter
fi

gettext "Network has been successfully configured. Please reboot your operating system."; echo
